RC(7)

NAME
rc - manual page for rc 2.38.130

SYNOPSIS
rc [OPTION]...

DESCRIPTION
rc is the RTags client application.

OPTIONS

--verbose|-v
    Be more verbose.

--version
    Print current version.

--verify-version|-t [arg]
    Verify that the correct protocol version is used.

--silent|-Q
    Be silent.

--help|-h
    Display this help.

--config [arg]
    Use this file (instead of ~/.rcrc).

--no-rc
    Don't load any rc files.

  Rdm:

--quit-rdm|-q
    Tell server to shut down with optional exit code as argument.

--connect-timeout [arg]
    Timeout for connecting to rdm in ms (default 1000).

  Project management:

--clear|-C
    Clear projects.

--project|-w [optional]
    With arg, select project matching that if unique, otherwise list all projects.

--delete-project|-W [arg]
    Delete all projects matching regex.

--job-count|-j [optional]
    Set or query current job count. (Prefix with l to set low-priority-job-count).

  Indexing commands:

--compile|-c [optional]
    Pass compilation arguments to rdm.

--guess-flags
    Guess compile flags (used with -c).

--load-compile-commands|-J [optional]
    Load compile_commands.json from directory

--suspend|-X [optional]
    Dump suspended files (don't track changes in these files) with no arg. Otherwise toggle suspension for arg.

  Query commands:

--follow-location|-f [arg]
    Follow this location.

--references-name|-R [arg]
    Find references matching arg.

--references|-r [arg]
    Find references matching this location.

--list-symbols|-S [optional]
    List symbol names matching arg.

--find-symbols|-F [optional]
    Find symbols matching arg.

--symbol-info|-U [arg]
    Get cursor info for this location.

--status|-s [optional]
    Dump status of rdm. Arg can be symbols or symbolNames.

--diagnose [arg]
    Resend diagnostics for file.

--diagnose-all
    Resend diagnostics for all files.

--last-indexed
    Get timestamp of the last time indexing completed for the current project.

--is-indexed|-T [arg]
    Check if rtags knows about, and is ready to return information about, this source file.

--is-indexing [optional]
    Check if rtags is currently indexing files in any project or in project matching pattern.

--has-filemanager [optional]
    Check if rtags has info about files in this directory.

--preprocess|-E [arg]
    Preprocess file.

--asm [arg]
    Assemble file.

--reindex|-V [optional]
    Reindex all files or all files matching pattern.

--check-reindex|-x [optional]
    Check if reindexing is necessary for all files matching pattern.

--path|-P [optional]
    Print files matching pattern.

--current-project
    Print path for current project.

--dump-file|-d [arg]
    Dump source file.

--check-includes [arg]
    Check includes for source file.

--dump-file-maps [arg]
    Dump file maps for file.

--generate-test [arg]
    Generate a test for a given source file.

--rdm-log|-g
    Receive logs from rdm.

--fixits [arg]
    Get fixits for file.

--remove|-D [arg]
    Remove file from project.

--find-project-root [arg]
    Use to check behavior of find-project-root.

--find-project-build-root [arg]
    Use to check behavior of find-project-root for builds.

--include-file [arg]
    Use to generate include statement for symbol.

--sources [optional]
    Dump sources for source file.

--dependencies [arg]
    Dump dependencies for source file [(includes, included-by, depends-on, depended-on, tree-depends-on, raw)].

--all-dependencies
    Dump dependencies for all source files [(includes, included-by, depends-on, depended-on, tree-depends-on, raw)].

--reload-file-manager|-B
    Reload file manager.

--code-complete-at|-l [arg]
    Code complete at location: arg is file:line:col.

--send-diagnostics [arg]
    Only for debugging. Send data to all -G connections.

--dump-completions
    Dump cached completions.

--dump-compile-commands
    Dump compilation database for project.

--set-buffers [optional]
    Set active buffers (list of filenames for active buffers in editor).

--list-buffers
    List active buffers.

--add-buffers [arg]
    Add additional buffers.

--remove-buffers [arg]
    Remove buffers.

--list-cursor-kinds
    List spelling for known cursor kinds.

--class-hierarchy [arg]
    Dump class hierarcy for struct/class at location.

--debug-locations [optional]
    Manipulate debug locations.

--validate
    Validate database files for current project.

--tokens [arg]
    Dump tokens for file. --tokens file.cpp:123-321 for range.

--find-dead-functions [optional]
    Find functions declared/defined in the current file that are never in the project.

  Command flags:

--strip-paren|-p
    Strip parens in various contexts.

--max|-M [arg]
    Max lines of output for queries.

--reverse-sort|-O
    Sort output reversed.

--rename
    Used for --references to indicate that we're using the results to rename symbols.

--unsaved-file [arg]
    Pass unsaved file on command line. E.g. --unsaved-file=main.cpp:1200 then write 1200 bytes on stdin.

--log-file|-L [arg]
    Log to this file.

--no-context|-N
    Don't print context for locations.

--path-filter|-i [arg]
    Filter out results not matching with arg.

--dependency-filter [arg]
    Filter out results unless argument depends on them.

--range-filter [arg]
    Filter out results not in the specified range.

--filter-system-headers|-H
    Don't exempt system headers from path filters.

--all-references|-e
    Include definitions/declarations/constructors/destructors for references. Used for rename symbol.

--target-usrs
    Print all matching usr targets for -f. Used for debugging.

--all-targets
    Print multiple targets for -f. Sorted by best match.

--elisp|-Y
    Output elisp: (list "one" "two" ...).

--json
    Output json.

--json-diagnostics-include-skipped
    Output json diagnostics with skipped ranges.

--diagnostics|-m
    Receive async formatted diagnostics from rdm.

--match-regexp|-Z
    Treat various text patterns as regexps (-P, -i, -V, -F).

--match-icase|-I
    Match case insensitively

--absolute-path|-K
    Print files with absolute path.

--socket-file|-n [arg]
    Use this socket file (default ~/.rdm).

--socket-address [arg]
    Use this host:port combination (instead of --socket-file).

--timeout|-y [arg]
    Max time in ms to wait for job to finish (default no timeout).

--find-virtuals|-k
    Use in combinations with -R or -r to show other implementations of this function.

--find-file-prefer-exact|-A
    Use to make --find-file prefer exact matches over partial matches.

--symbol-info-include-parents
    Use to make --symbol-info include parent symbols.

--symbol-info-include-targets
    Use to make --symbol-info include target symbols.

--symbol-info-include-references
    Use to make --symbol-info include reference symbols.

--symbol-info-include-base-classes
    Use to make --symbol-info include baseclasses' symbols.

--symbol-info-include-source-code
    Use to make --symbol-info include source code.

--cursor-kind
    Include cursor kind in --find-symbols output.

--display-name
    Include display name in --find-symbols output.

--current-file [arg]
    Pass along which file is being edited to give rdm a better chance at picking the right project.

--declaration-only|-G
    Filter out definitions (unless inline).

--definition-only
    Filter out declarations (unless inline).

--kind-filter [arg]
    Only return results matching this kind.

--containing-function|-o
    Include name of containing function in output.

--containing-function-location
    Include location of containing function in output.

--build-index [arg]
    For sources with multiple builds, use the arg'th.

--compilation-flags-only
    For --source, only print compilation flags.

--compilation-flags-split-line
    For --source, print one compilation flag per line.

--compilation-flags-pwd
    For --source, print pwd for compile command on the first line.

--dump-include-headers
    For --dump-file, also dump dependencies.

--silent-query
    Don't log this request in rdm.

--synchronous-completions
    Wait for completion results and print them to stdout.

--synchronous-diagnostics
    Wait for diagnostics and print them to stdout.

--xml
    Output XML

--no-sort-references-by-input
    Don't sort references by input position.

--project-root [arg]
    Override project root for compile commands.

--rtags-config [arg]
    Print out .rtags-config for argument.

--wildcard-symbol-names|-a
    Expand * like wildcards in --list-symbols and --find-symbols.

--no-color|-z
    Don't colorize context.

--wait
    Wait for reindexing to finish.

--code-complete-include-macros
    Include macros in code completion results.

--code-complete-includes
    Give includes in completion results.

--code-complete-no-wait
    Don't wait for synchronous completion if the translation unit has to be created.

--code-complete-prefix [arg]
    Filter out code completion results that don't start with this prefix.

--code-completion-enabled|-b
    Inform rdm that we're code-completing. Use with --diagnose

--no-spell-checking
    Don't produce spell check info in diagnostics.

--tokens-include-symbols
    Include symbols for tokens.

--no-realpath
    Don't resolve paths using realpath(3).

--include-path [arg]
    Dump include path for symbol.

--max-depth [arg]
    Max search depth. Used for --include-path.

SEE ALSO
rdm(7)